Bug 5957 - Fix pthread_join() on HPPA with kernel having private futex support
Summary: Fix pthread_join() on HPPA with kernel having private futex support
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: ports (show other bugs)
Version: unspecified
: P2 normal
Target Milestone: ---
Assignee: Carlos O'Donell
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-03-18 12:48 UTC by Guy Martin
Modified: 2014-07-01 21:20 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Last reconfirmed:
fweimer: security-


Attachments
Use shared futex in lll_wait_tid(). (431 bytes, patch)
2008-03-18 12:49 UTC, Guy Martin
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Guy Martin 2008-03-18 12:48:55 UTC
pthread_join() on HPPA doesn't resume current thread execution when the joined
thread terminates.
This is due to the fact that glibc waits incorrectly on a private futex.
Comment 1 Guy Martin 2008-03-18 12:49:30 UTC
Created attachment 2331 [details]
Use shared futex in lll_wait_tid().
Comment 2 Carlos O'Donell 2008-04-08 13:56:25 UTC
Thanks. I'll look at this.
Comment 3 cvs-commit@gcc.gnu.org 2008-06-17 11:45:05 UTC
Subject: Bug 5957

CVSROOT:	/cvs/glibc
Module name:	ports
Changes by:	carlos@sourceware.org	2008-06-17 11:44:25

Modified files:
	.              : ChangeLog.hppa 
	sysdeps/unix/sysv/linux/hppa/nptl: lowlevellock.h 

Log message:
	2008-06-17  Guy Martin  <gmsoft@tuxicoman.be>
	
	[BZ #5957]
	* sysdeps/unix/sysv/linux/hppa/nptl/lowlevellock.h:
	Use shared futex in lll_wait_tid().

Patches:
http://sourceware.org/cgi-bin/cvsweb.cgi/ports/ChangeLog.hppa.diff?cvsroot=glibc&r1=1.46&r2=1.47
http://sourceware.org/cgi-bin/cvsweb.cgi/ports/sysdeps/unix/sysv/linux/hppa/nptl/lowlevellock.h.diff?cvsroot=glibc&r1=1.7&r2=1.8

Comment 4 Carlos O'Donell 2008-06-17 11:56:24 UTC
Fixed on head.